<template>
  <div>
    <v-row justify="center">
      <v-col md="10">
        <div class="float-left text-h6 font-weight-bold">
          Estos documentos podrían ser de tu interés
        </div>
        <div class="float-right">
          <v-select
            class="pt-0 mt-0"
            v-model="select"
            :items="items"
            item-text="search"
            item-value="code"
            persistent-hint
            placeholder="Seleccionar"
            return-object
            single-line
          />
        </div>
      </v-col>
    </v-row>
    <v-row justify="center">
      <v-col :md="10">
        <v-row>
          <template v-for="(folio, indexFolio) in folios">
            <v-col :cols="12" :key="indexFolio" :lg="4" :md="3" :sm="6" :xl="2">
              <Documento :folio="folio" />
            </v-col>
          </template>
        </v-row>
      </v-col>
    </v-row>
  </div>
</template>
<script>
import store from "@/store";
import Documento from "@/views/secure/modelo-negocio/documentos/visualizador/folios/usuario/publicados/components/Documento.vue";
const axios = store.state.axiosApiLocal;
const serviceLocalStorage = store.state.serviceLocalStorage;
export default {
  name: "ListaPublicados",
  components: {
    Documento,
  },
  data() {
    return {
      select: { search: "Más vistos", code: 5 },
      items: [
        { search: "Recientes", code: 1 },
        { search: "Mejor calificados", code: 2 },
        { search: "Última semana", code: 3 },
        { search: "Anteriores", code: 4 },
        { search: "Más vistos", code: 5 },
      ],
      folios: [],
    };
  },
  watch: {
    select(val, prev) {
      if (val) {
        this.getFoliosPublicados(val.code);
      }
    },
  },
  computed: {
    user() {
      let user = serviceLocalStorage.userToken();
      if (!user) {
        user = {};
      }
      return user;
    },
  },
  methods: {
    getFolioArchivosVirtuales(indexFolio) {
      let folio = this.folios[indexFolio];
      folio.loading = true;
      axios(
        "/modelo-negocio/folio-virtuales-archivos/v1/" +
          folio.idFolio +
          "/virtuales/archivos"
      )
        .then((response) => {
          let data = response.data;
          if (data) {
            let files = data.resultado.folioVirtualesArchivos.filter(
              (item) => item.tipo == 1
            );
            if (files.length > 0) {
              folio.archivoDemo = files[0];
            }
          }
        })
        .catch((error) => {
          if (error.response) {
            console.log(error.response.data);
          }
        });
    },
    getFoliosPublicados(tipo) {
      const self = this;
      this.loading = true;
      let uri = "";
      if (tipo == 1) {
        uri =
          "/modelo-negocio/folios/v1/busquedas/usuarios/" +
          this.user.empleado +
          "/documentos/publicados/recientes";
      } else if (tipo == 2) {
        uri =
          "/modelo-negocio/folios/v1/busquedas/usuarios/" +
          this.user.empleado +
          "/documentos/publicados/mejor-calificados";
      } else if (tipo == 3) {
        uri =
          "/modelo-negocio/folios/v1/busquedas/usuarios/" +
          this.user.empleado +
          "/documentos/publicados/ultima-semana";
      } else if (tipo == 4) {
        uri =
          "/modelo-negocio/folios/v1/busquedas/usuarios/" +
          this.user.empleado +
          "/documentos/publicados/ultimo-mes";
      } else {
        uri =
          "/modelo-negocio/folios/v1/busquedas/usuarios/" +
          this.user.empleado +
          "/documentos/publicados/mas-vistos";
      }
      axios(uri)
        .then((response) => {
          let data = response.data;
          if (data) {
            let folios = data.resultado.folios;
            folios.forEach((element, indexElement) => {
              element.archivoDemo = null;
              element.loading = null;
            });
            self.folios = folios;
            self.folios.forEach((element, indexElement) => {
              self.getFolioArchivosVirtuales(indexElement);
            });
          }
        })
        .catch((error) => {
          self.folios = [];
          console.log(error);
        })
        .finally(() => {
          self.loading = false;
        });
    },
  },
  created() {
    this.getFoliosPublicados(1);
  },
};
</script>
